#ifndef _QTCHESS_COMM_
#define _QTCHESS_COMM_

#define BUFFER_SIZE 1024

/*
** -- System Includes --
*/

extern "C"
{
#include <stdio.h>
}

/*
** -- Qt Includes --
*/

#include <qmutex.h>
#include <qstring.h>
#include <qthread.h>
#include <qsocketdevice.h>

/*
** -- Local Includes --
*/

#include "qtchess.h"
#include "qtchess_defs.h"

class qtchess_comm_thread: public QThread
{
 public:

  /*
  ** -- Members --
  */

  /*
  ** -- Methods --
  */

  qtchess_comm_thread(void)
    {
      interrupted = FALSE;
    }

  int wasInterrupted(void)
    {
      return interrupted;
    }

  void setInterrupted(const int interrupted_arg)
    {
      this->interrupted = interrupted_arg;
    }

  virtual void run(void);

 private:

  /*
  ** -- Members --
  */

  int interrupted;

  /*
  ** -- Methods --
  */
};

class qtchess_comm
{
 public:

  /*
  ** -- Members --
  */

  /*
  ** -- Methods --
  */

  qtchess_comm(void);

  ~qtchess_comm()
    {
      quit();
#ifdef _DEBUG_
      (void) fprintf(stderr, "~qtchess_comm()\n");
#endif
    }

  QSocketDevice *getSendSock(void)
    {
      return send_sock;
    }

  int isSet(void);
  int isReady(void);
  void init(void);
  void quit(void);
  void sendMove(const struct move_s);
  void setListen(void);
  void setConnected(const int);
  void connectRemotely(void);
  void disconnectRemotely(void);
  QSocketDevice *getListener(void);

 private:

  /*
  ** -- Members --
  */

  int connected;
  QSocketDevice *send_sock;
  QSocketDevice *listening_sock;
  qtchess_comm_thread *conn_thread;

  /*
  ** -- Methods --
  */
};

#endif
